package taidegalleria;

import java.io.OutputStream;
import java.io.PrintStream;

/**
 * @author lainejee
 * @version 1.0 24.2.2025
 * |------------------------------------------------------------------------|
 * | Luokan nimi:   Taiteilija                          | Avustajat:        |
 * |-------------------------------------------------------------------------
 * | Vastuualueet:                                      |                   |
 * |                                                    |                   |
 * | (- Ei tiedä tietokannasta eikä käyttöliittymästä.) |                   |
 * |  - Tietää taiteilijan kentät (nimi, ikä, jne.)     |                   |
 * |  - Osaa tarkistaa tietyn kentän oikeellisuuden.    |                   |
 * |  - Osaa muuttaa 1|Edward Hopper|..|-merkkijonon    |                   |
 * |    jäsenen tiedoiksi.                              |                   |
 * |  - Osaa antaa merkkijonona indeksin kentän tieodt. |                   |
 * |  - Osaa laittaa merkkijonon indeksin kentäksi.     |                   |
 * |                                                    |                   |
 * |                                                    |                   |
 * |                                                    |                   |
 * |                                                    |                   |
 * |                                                    |                   |
 * |                                                    |                   |
 * |-------------------------------------------------------------------------
 */
public class Taiteilija {

    private int id = 0;
    private String nimi = "";
    private int syntynyt = 0;
    private int kuollut = 0;
    private int ika = 0;
    private String kansalaisuus = "";
    private String tyylisuunta = "";

    public static int seuraavaId = 1;


    /**
     * Muodostaa tyhjän taiteilijan.
     */
    public Taiteilija() {
        // Ei tarvita vielä.
    }


    /**
     * @return taiteilijan nimi
     */
    public String getNimi() {
        return this.nimi;
    }


    /**
     * Tulostetaan taiteilijan tiedot.
     * @param out tietovirta johon tulostetaan
     */
    public void tulosta(PrintStream out) {
        out.println(id + " " + nimi);
        out.println("Syntynyt: " + syntynyt + " Kuollut: " + kuollut + " Ikä: " + ika);
        out.println("Kansalaisuus: " + kansalaisuus + " Tyylisuunnat: " + tyylisuunta);
    }


    /** Ei tarvita vielä: */
    // public void tulosta(OutputStream os) { tulosta(new PrintStream(os)); }


    /**
     * Antaa taiteilijalle seuraavan id:n.
     * @return taiteilijan uusi tunnusId
     * @example
     * <pre name="test">
     *     Taiteilija a1 = new Taiteilija();
     *     a1.getId() === 0;
     *     a1.rekisteroi();
     *     Taiteilija a2 = new Taiteilija();
     *     a2.rekisteroi();
     *     int n1 = a1.getId();
     *     int n2 = a2.getId();
     *     n1 === n2-1;
     * </pre>
     */
    public int rekisteroi() {
        this.id = seuraavaId;
        seuraavaId++;
        return this.id;
    }


    /**
     * Palauttaa taiteilijan id:n.
     * @return taiteilijan id
     */
    public int getId() {
        return id;
    }


    /**
     * Täytetään taiteilija tiedoilla testaamista varten.
     */
    public void tayta() {
        nimi = "Hiroshige" ;
        syntynyt = 1797;
        kuollut = 1858;
        ika = 61;
        kansalaisuus = "Japani";
        tyylisuunta = "Ukiyo-e";
    }


    /**
     * Testataan taiteilija-luokkaa.
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Taiteilija hiroshige = new Taiteilija();
        Taiteilija edward = new Taiteilija();

        hiroshige.rekisteroi();
        edward.rekisteroi();

        hiroshige.tulosta(System.out);
        edward.tulosta(System.out);

        hiroshige.tayta();
        edward.tayta();

        hiroshige.tulosta(System.out);
        edward.tulosta(System.out);

    }

}
