package fxtaidegalleria;

import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.collections.FXCollections;
import javafx.fxml.FXML;
import javafx.scene.control.ComboBox;
import javafx.stage.Stage;

public class TietokannanNimiController implements ModalControllerInterface<String> {


    @FXML private ComboBox<String> valitseTietokanta;
    private String vastaus = null;


    @FXML private void initialize() {
        valitseTietokanta.setItems(FXCollections.observableArrayList("suosikit"));
    }


    @FXML private void handleOK() {
        vastaus = valitseTietokanta.getValue();
        if (vastaus == null) return;
        ModalController.closeStage(valitseTietokanta);
    }


    @FXML private void handleCancel() {
        ModalController.closeStage(valitseTietokanta);
    }


    @Override
    public String getResult() {
        return vastaus;
    }


    @Override
    public void setDefault(String oletus) {
        valitseTietokanta.setItems(FXCollections.observableArrayList("suosikit"));
    }



    @Override
    public void handleShown() {
        valitseTietokanta.requestFocus();
    }


    /**
     * Luodaan tietokannan valitsemis dialogi. Palautetaan dropdown menusta valittu
     * nimi tai null.
     * @param modalityStage mille ollaan modaalisia, null = sovellukselle
     * @param oletus nimi joka näytetään oletuksena
     * @return null jos painetaan Cancel, muuten menusta valittu tietokanta
     */
    public static String kysyNimi(Stage modalityStage, String oletus) {
        return ModalController.showModal(
                TietokannanNimiController.class.getResource("TietokannanNimiView.fxml"),
                "Valitse tietokanta",
                modalityStage, oletus);
    }


}
